Description

Hi,

it seems I am having some problems when importing classes. After a lot of trials I think I should raise this issue with you, nothing

helped till now.

Our scenario and current setup:

OS: SLES 12.1

puppet master:*3.8.5 (os installed)

*smart-proxy: 1.13.1 (installed from source)

foreman: 1.13.1 (installed from source)

Notes:

1. Our smart/foreman/puppetmaster all reside on 1 server

2. Our smart/foreman are deployed under a separate user deployer (deployer is a member of puppet group), using rvm and ruby

2.3.0.please see attached

3. Our puppet master is OS installed under ruby 2.1.0

Previous setup: I've previously tried versions 1.12.0, 1.12.1 for smart and foreman + directory environments + r10k - puppet working

fine--> getting in the same place. Environments where detected correctly (dev, prod, uat), but when  smart-proxy --> importing

classes --> "No changes detected to your environment"

Current setup: no directory environments, just single default production environment --> importing classes --> "No changes detected

to your environment"

the smart proxy/foreman: has gems --> please see deployeruser_gems.log

Attached also config files.

Can you please help us related?

Related issues:

Related to Foreman - Support #9091: Import Puppet Environments Resolved 01/23/2015

History

#1 - 11/23/2016 07:26 AM - Slagian Momirovici

- Related to Support #9091: Import Puppet Environments added

#2 - 11/23/2016 07:30 AM - Slagian Momirovici

- File smartproxy_puppet.yml added

- File smartproxy_puppet_proxy_legacy.yml added

#3 - 11/23/2016 07:31 AM - Slagian Momirovici

- File smartproxy_settings.yml added

#4 - 11/23/2016 08:34 AM - Dominic Cleal

- Category changed from Smart Proxy to Puppet integration
The smart proxy log looks reasonably successful, it's listing manifests that are being parsed for classes. I'd suggest one these options is likely:

1. The manifests are failing to parse, the smart proxy may not list errors. Use puppet parser validate to check.

2. The manifests don't contain classes.

3. The classes are ignored by Foreman's ignored_environments.yml

Can you view the output of the smart proxy API call by using cURL? e.g. curl http://proxy.example.com:8000/puppet/environments/production/classes

#5 - 11/23/2016 10:24 AM - Dominic Cleal

- Tracker changed from Bug to Support

#6 - 11/24/2016 04:52 AM - Slagian Momirovici

oki, I will test this today and update.

#7 - 11/24/2016 06:10 AM - Slagian Momirovici

- File smarproxy_logs241116 added

Hi Dominic,

Back with answers:

Note: I have left only 2 modules, removed * of them for debugging purposes. And replaced "import module" with "include module" in site.pp

stdlib

logrotate

--------------------------

The smart proxy log looks reasonably successful, it's listing manifests that are being parsed for classes. I'd suggest one these options is likely:

The manifests are failing to parse, the smart proxy may not list errors. Use puppet parser validate to check.    ---> Parsing fine now

The manifests don't contain classes.  ---> contains classes

The classes are ignored by Foreman's ignored_environments.yml   - in foreman I have only config/ignored_environments.yml.sample, it is not

used

Can you view the output of the smart proxy API call by using cURL? e.g. curl http://proxy.example.com:8000/puppet/environments/production/classes

A: curl http://puppetmaster2.phgroup.com:8000/puppet/environments/production/classes --> []

it does not see them it seems.

#8 - 11/24/2016 06:30 AM - Dominic Cleal

- Project changed from Foreman to Smart Proxy

- Category changed from Puppet integration to Puppet

Thanks, that does confine the problem to the smart proxy, but doesn't show any likely cause.

Re-reading the description, I'm unsure that Puppet and the smart proxy are correctly set up.

puppet master:*3.8.5 (os installed)

[..]

2. Our smart/foreman are deployed under a separate user deployer (deployer is a member of puppet group), using rvm and ruby 2.3.0.please

see attached

 The "Syck" errors in your deployeruser_gems.log file is because Puppet 3.x is being used under Ruby 2.3.0, which isn't compatible (see 

https://docs.puppet.com/guides/platforms.html#ruby-versions).

The smart proxy when using Puppet 3.x will need to load Puppet to parse manifests, so it must be run under a mutually compatible version. I'd

suggest trying to run the smart proxy under 2.1.0 as well (or upgrade to Puppet 4, which doesn't have these issues).

Lastly, there are both Puppet 4 and 3 gems listed in the Bundler output, so ensure you run the smart proxy with bundle exec to use the one specified

in your Gemfile/Gemfile.lock. If not then it might be trying to use Puppet 4.

#9 - 11/25/2016 11:45 AM - Slagian Momirovici

Dominic, works fine ), thank you very much --> so the issue was ruby version, my fault

I've setup also directory environments and picked ok.

-----------------------------------------------

However I have a small question?

How can I change "foreman" log path? currently goes to ./foreman/log/production.log

I've tried in settings.yaml and logging.yaml the bellow settings and no avail ~ it will not record logs under none of the paths then, complains that no

appender was set and going to STDOUT, however STDOUT has nothing.
#:default:

1. :colorize: false

2. :console_inline: false

3. :log_trace: true

4. :level: debug

5. :type: file

6. :pattern: "%d .8X{session} [%c] [.1l] %m\n"

#:production:

1. :filename: "/var/log/ph/foreman/production.log"

#10 - 11/25/2016 12:48 PM - Slagian Momirovici

- Status changed from New to Resolved

It seems i missread doc, all ok and thank you.

Files

deployeruser_gems.log 3.46 KB 11/23/2016 Slagian Momirovici

puppet.conf 1.61 KB 11/23/2016 Slagian Momirovici

smartproxy_log.log 2.95 KB 11/23/2016 Slagian Momirovici

foreman_log.log 1.37 KB 11/23/2016 Slagian Momirovici

smartproxy_puppet_proxy_legacy.yml 817 Bytes 11/23/2016 Slagian Momirovici

smartproxy_puppet.yml 485 Bytes 11/23/2016 Slagian Momirovici

smartproxy_settings.yml 1.88 KB 11/23/2016 Slagian Momirovici

smarproxy_logs241116 1.63 KB 11/24/2016 Slagian Momirovici
